<?php
require_once("config.php");
$table = "events";
header("Access-Control-Allow-Orgin: *");
header("Access-Control-Allow-Methods: *");
header("Content-Type: application/json");
$requestUri = explode("/", trim($_SERVER["REQUEST_URI"],"/"));
$requestParams = $_REQUEST;

$method = $_SERVER["REQUEST_METHOD"];

try {
	$db = new PDO($dsn, $username, $password);
	$status = "200";
	$statusText = "OK";

	switch ($method) {
		case "GET":
			$queryParams = [];
			$queryText = "SELECT * FROM `".$table."`";
			if (isset($requestParams["from"]) && isset($requestParams["to"])) {
				$queryText .= " WHERE `end_date`>=? AND `start_date` < ?;";
				$queryParams = [$params["from"], $params["to"]];
			}
			$query = $db->prepare($queryText);
			$query->execute($queryParams);
			$result = $query->fetchAll();
		break;
		case "POST":
			$requestPayload = json_decode(file_get_contents("php://input"));
			$id = $requestPayload->id;
			$action = $requestPayload->action;
			$body = (array) $requestPayload->data;
			$statusText = $action;
			if ($action == "inserted") {
				$queryText = "INSERT INTO `".$table."` SET
							`start_date`=?,
							`end_date`=?,
							`text`=?";
				$queryParams = [
					$body["start_date"],
					$body["end_date"],
					$body["text"]
				];

				$query = $db->prepare($queryText);
				$query->execute($queryParams);
				$result = [
					"tid" => $db->lastInsertId(),
					"action" => "inserted"
				];
			} elseif($action == "updated") {
				$queryText = "UPDATE `".$table."` SET
				`start_date`=?,
				`end_date`=?,
				`text`=?
				WHERE `id`=?";

				$queryParams = [
					$body["start_date"],
					$body["end_date"],
					$body["text"],
					$id
				];

				$query = $db->prepare($queryText);
				$query->execute($queryParams);

				$result = [
					"action" => "updated"
				];
			} elseif($action == "deleted") {
				$queryText = "DELETE FROM `".$table."` WHERE `id`=? ;";

				$query = $db->prepare($queryText);
				$query->execute([$id]);

				$result = [
					"action" => "deleted"
				];
			}
		break;
		default: throw new Exception("Unexpected Method"); break;
	}
} catch (Exception $e) {
	$status = "500";
	$statusText = "Server error";
	$result = [
		"action" => "error",
		"message" => $e->getMessage()
	];
}
header("HTTP/1.1 " . $status . " " . $statusText);
$payload = json_encode($result);
echo $payload;